/**
 * @file lagoon/ranges.hpp
 * @brief Range utilities
 *
 *  Copyright 2008-2011 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef LAGOON_RANGES_1011291729_HPP
#define LAGOON_RANGES_1011291729_HPP


LAGOON_NAMESPACE_BEGIN

/** @defgroup lagoon_ranges Lagoon - Range utilities
 *
 *  Lagoon provides an extensive set of utilities for tasks like
 *  range transformation, filtering, sorting, searching, etc. which
 *  make writing complex range manipulating algorithms easier and
 *  more straightforward.
 */

LAGOON_NAMESPACE_END

#include <lagoon/range/for_each.hpp>
#include <lagoon/range/fold.hpp>
#include <lagoon/range/transform.hpp>
#include <lagoon/range/contains.hpp>
#include <lagoon/range/find_if.hpp>
#include <lagoon/range/only_if.hpp>
#include <lagoon/range/limit.hpp>
#include <lagoon/range/offset.hpp>
#include <lagoon/range/sort.hpp>
#include <lagoon/range/until.hpp>
#include <lagoon/range/chain.hpp>
#include <lagoon/range/link.hpp>
#include <lagoon/range/extract.hpp>
#include <lagoon/range/flatten.hpp>
//
#include <lagoon/range/std_range.hpp>
#endif //include guard

